# ==== first_turing_bombe.py :

import sys
import enigmaM3noTurn
import string	
import getopt
ALPHA = string.ascii_uppercase

# ===================================
def is_maj(car):
	if string.ascii_uppercase.find(car) == -1: 
		return 0
	else:
		return 1
# ===================================
def addGrund( aGrund, left, middle, right):
    x = ALPHA.find( aGrund[0] )
    y = ALPHA.find( aGrund[1] )
    z = ALPHA.find( aGrund[2] )
    newGrund = ALPHA[(x+left)%26] + ALPHA[(y+middle)%26] + ALPHA[(z+right)%26]
    return newGrund
# ===================================
def usage():
    print("Usage:")
    print(" -h          Online Help")
    print(" -d          Debug")
    print(" -W X,Y,Z    The Walzenlage, default: -W I,II,III")
    print(" -U UKW      The Reflector, default: B")
    print(" -T a,b,...  The terminal letter(s)")
    print(" You can put only one letter if it is the same")
    print(" It takes as many letters as there are loops")
    print(" -M menu     The menu, for example:")
    print(" -M ZZA:ZZB,ZZC:ZZC:ZZD : 2 loops")
    print(" Note: The input letter start each loop")
    print(" -I XYZ      The indicator position ")
    print("             by default, the first entry of the menu")
# ===================================
try:
    opts, args = getopt.getopt(sys.argv[1:],
        "hdW:U:T:M:I:", ["help","debug","walzenlage=","ukw=",
        "terminal=","menu=", "indicator=" ])
except getopt.GetoptError as err:
    usage()
    sys.exit(2)
# ===================================
UKW    = 'B'
LEFT   = 'I'
MIDDLE = 'II'
RIGHT  = 'III'
WALZENLAGE = "I,II,III"
LETTERS = ['A']*10
DEBUG = False
MENU = []
RING = "AAA"
STECKS = ""
GRUND = "AAA"
INDICATOR = ""

for o, a in opts:
    if o in ("-h", "--help"):
        usage()
        sys.exit()
    elif o in ("-d", "--debug"):
        DEBUG = True
    elif o in ("-U", "--ukw"):
        UKW = a
    elif o in ("-W", "--walzenlage"):
        WALZENLAGE = a
    elif o in ("-T", "--terminal"):
        if "," in a:
            LETTERS = a.split(",")
        else:
            LETTERS = [a]*10
    elif o in ("-M", "--menu"):
        tb = a.split(",")
        for aTb in tb:
            MENU.append( aTb.split(":") )
    elif o in ("-I", "--indicator"):
        INDICATOR = a
    else:
        assert False, "unhandled otpion"
if len(MENU) == 0:
    usage()
    sys.exit(1)
#==============================================
if INDICATOR == "":
    INDICATOR = MENU[0][0]
e = [] # les enigmas
LEFT,MIDDLE,RIGHT = WALZENLAGE.split(",")
for i in range(20):
    e.append( enigmaM3noTurn.Enigma(UKW,LEFT,MIDDLE,RIGHT, STECKS, RING, GRUND, 0))
if DEBUG:
    print(MENU)
    print(LETTERS[0:len(MENU)])
    print(INDICATOR)
    print(UKW, WALZENLAGE)
for g_l in range(26):
 for g_m in range(26):
  for g_r in range(26):
   i = 0 ; good = 0 
   for j in range(len(MENU)):
     aMenu = MENU[j]
     car = LETTERS[j]
     for aGrund in aMenu:
        aGrund = addGrund( aGrund, g_l, g_m, g_r)
        e[i].setGrund( aGrund )
        car = e[i].encode( car )
        i += 1
     if car == LETTERS[j]: good += 1
   if good == len(MENU):
     STOP = addGrund( INDICATOR, g_l, g_m, g_r )
     print("stop", WALZENLAGE, LETTERS[0:len(MENU)], STOP)


